=== modified file 'NEWS'
--- NEWS	2007-12-06 23:53:08 +0000
+++ NEWS	2007-12-07 06:36:56 +0000
@@ -56,6 +56,9 @@
    * Fall back to showing e-mail in ``log --short/--line`` if the committer/author has
      only e-mail. (Lukáš Lalinský, #157026)
 
+   * Implement _make_parents_provider on RemoteRepository, allowing generating
+     bundles against branches on a smart server.  (Andrew Bennetts, #147836)
+
   API BREAKS:
 
    * Deprecate not passing a ``location`` argument to commit reporters'

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2007-11-30 23:27:18 +0000
+++ bzrlib/remote.py	2007-12-07 06:36:56 +0000
@@ -895,6 +895,10 @@
         self._ensure_real()
         return self._real_repository._check_for_inconsistent_revision_parents()
 
+    def _make_parents_provider(self):
+        self._ensure_real()
+        return self._real_repository._make_parents_provider()
+
 
 class RemoteBranchLockableFiles(LockableFiles):
     """A 'LockableFiles' implementation that talks to a smart server.

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2007-11-30 02:28:51 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2007-12-07 06:36:56 +0000
@@ -629,6 +629,13 @@
             self.get_vfs_only_url('remote')).open_repository()
         self.assertEqual(remote_backing_repo._format, local_repo._format)
 
+    def test__make_parents_provider(self):
+        """Repositories must have a _make_parents_provider method that returns
+        an object with a get_parents method.
+        """
+        repo = self.make_repository('repo')
+        repo._make_parents_provider().get_parents
+
 
 class TestRepositoryLocking(TestCaseWithRepository):
 

